<?php

define('IN_FORUM', true);
define('BB_SCRIPT', 'actors');
define('BB_ROOT', './');
require(BB_ROOT .'common.php');


$user->session_start(array('req_login' => true));

$mode = isset($_REQUEST['mode']) ? $_REQUEST['mode'] : '';
$act_id = request_var('id', '');

if (!empty($mode)) {
	switch ($mode) {
		case 'add':
		case 'edit':

			$s_hidden_fields = '';

			if ($mode === 'edit')
			{
				if (empty($act_id))
				{
					bb_die($lang['MUST_SELECT_RANK']);
				}

				$sql = "SELECT * FROM " . BB_ACTORS . " WHERE actor_id = ". $act_id;
				if (!$result = DB()->sql_query($sql))
				{
					bb_die('Could not obtain ranks data #1');
				}

				$actor_info = DB()->sql_fetchrow($result);
				$s_hidden_fields .= '<input type="hidden" name="id" value="'. $act_id .'" />';
			}

			$s_hidden_fields .= '<input type="hidden" name="mode" value="save" />';

			$actor_career = !empty($actor_info['actor_gender']) ? $actor_info['actor_gender'] : 0;

			$template->assign_vars(array(
				'TPL_ACTOR_EDIT' => true,

				'ACTOR_NAME_RU'		=> !empty($actor_info['actor_runame']) ? $actor_info['actor_runame'] : '',
				'ACTOR_NAME_EN'		=> !empty($actor_info['actor_enname']) ? $actor_info['actor_enname'] : '',
				'ACTOR_GENDER'		=> build_select('gender', array_flip($lang['GENDER_SELECT']), $actor_career),
				'ACTOR_CAREER'		=> !empty($actor_info['actor_career']) ? $actor_info['actor_career'] : '',
				'ACTOR_DESC'		=> !empty($actor_info['actor_desc']) ? $actor_info['actor_desc'] : '',
				'ACTOR_IMAGES'		=> !empty($actor_info['actor_foto']) ? $actor_info['actor_foto'] : '',
				'ACTOR_BIRTHDAY' 	=> !empty($actor_info['actor_birthdate']) ? $actor_info['actor_birthdate'] : '',

				'S_RANK_ACTION' => "actors.php",
				'S_HIDDEN_FIELDS' => $s_hidden_fields,
			));

			break;
		case 'save':
			$actor_id 		= (isset($_POST['id'])) ? intval($_POST['id']) : 0;

			$actor_nameru	= isset($_POST['runame']) ? trim($_POST['runame']) : '';
			$actor_nameen	= isset($_POST['enname']) ? trim($_POST['enname']) : '';
			$actor_gender	= isset($_POST['gender']) ? intval($_POST['gender']) : 0;
			$actor_desc		= isset($_POST['desc']) ? trim($_POST['desc']) : '';
			$actor_career	= isset($_POST['career']) ? trim($_POST['career']) : '';
			$actor_images	= isset($_POST['foto']) ? trim($_POST['foto']) : '';
			$actor_birthday	= isset($_POST['birthday']) ? trim($_POST['birthday']) : '';


			if ($actor_nameru === '' || $actor_nameen === '' )
			{
				bb_die($lang['NO_GROUP_NAME']);
			}

			$birthday_date = date_parse($actor_birthday);

			if (!empty($birthday_date['year']))
			{
				if (strtotime($actor_birthday) >= TIMENOW)
				{
					$errors[] = $lang['WRONG_BIRTHDAY_FORMAT'];
				}
				elseif (bb_date(TIMENOW, 'Y', false) - $birthday_date['year'] > $bb_cfg['birthday_max_age'])
				{
					$errors[] = sprintf($lang['BIRTHDAY_TO_HIGH'], $bb_cfg['birthday_max_age']);
				}
				elseif (bb_date(TIMENOW, 'Y', false) - $birthday_date['year'] < $bb_cfg['birthday_min_age'])
				{
					$errors[] = sprintf($lang['BIRTHDAY_TO_LOW'], $bb_cfg['birthday_min_age']);
				}
			}

			if ($actor_images != '')
			{
				if (!preg_match('/(\.gif|\.png|\.jpg)$/is', $actor_images))
				{
					$actor_images = '';
				}
			}

			$sql_ary = array(
				'actor_runame'		=> (string) $actor_nameru,
				'actor_enname'     => (string) $actor_nameen,
				'actor_career'		=> (string) $actor_career,
				'actor_gender'		=> (int) $actor_gender,
				'actor_desc'		=> (string) $actor_desc,
				'actor_foto'		=> (string) $actor_images,
				'actor_birthdate'	=> (string) $actor_birthday,
			);

			if ($actor_id) {

				$sql_args = DB()->build_array('UPDATE', $sql_ary);

				// Update group's data
				DB()->query("UPDATE " . BB_ACTORS . " SET $sql_args WHERE actor_id = ". $actor_id);

			}else{

				$sql_args = DB()->build_array('INSERT', $sql_ary);

				// Create new group
				DB()->query("INSERT INTO ". BB_ACTORS ." $sql_args");
				DB()->sql_nextid();
			}

			break;
	}
} else if($act_id !== ''){

	$sql = "SELECT * FROM " . BB_ACTORS . " WHERE actor_id = ". $act_id;
	if ($a_data = DB()->fetch_row($sql)) {

		$template->assign_vars(array(
			'TPL_ACTOR_VIEW' => true,

			'ACTOR_NAME_RU'  	=> $a_data['actor_runame'],
			'ACTOR_NAME_EN'  	=> $a_data['actor_enname'],
			'ACTOR_CAREER'   	=> $a_data['actor_career'],
			'ACTOR_IMAGES'   	=> (!empty($a_data['actor_foto'])) ? $a_data['actor_foto'] : '',
			'ACTOR_GENDER'   	=> $lang['GENDER_SELECT'][$a_data['actor_gender']],
			'ACTOR_DESC'     	=> $a_data['actor_desc'],

			'BIRTHDATA'         => bb_date(strtotime($a_data['actor_birthdate']), 'd F Y'),
			'AGE'               => birthday_age($a_data['actor_birthdate']),

			'U_ACTOR_EDIT'		=> "actors.php?mode=edit&amp;id=". $a_data['actor_id'],
		));
	} else {
		bb_die('Неверный запрос');
	}
}else {

	$sql = "SELECT * FROM " . BB_ACTORS . " ORDER BY actor_runame, actor_enname";
	if (!$result = DB()->sql_query($sql))
	{
		bb_die('Could not obtain actors data #2');
	}
	$actor_count = DB()->num_rows($result);
	$actor_rows = DB()->sql_fetchrowset($result);

	for ($i = 0; $i < $actor_count; $i++)
	{

		$template->assign_block_vars('actor', array(
			'ID'			=> $actor_rows[$i]['actor_id'],
			'RU_NAME'		=> $actor_rows[$i]['actor_runame'],
			'EN_NAME'		=> $actor_rows[$i]['actor_enname'],
			'AGE'			=> birthday_age($actor_rows[$i]['actor_birthdate']),
			'IMAGES'		=> (!empty($actor_rows[$i]['actor_foto'])) ? $actor_rows[$i]['actor_foto'] : '',

			'U_ACTOR'		=> "actors.php?id=". $actor_rows[$i]['actor_id'],
		));
	}

	$template->assign_vars(array(
		'TPL_ACTOR_LIST' => true,
		'COLL'		=> $actor_count,
	));

}

print_page('actors.tpl');